/*
 * $Id: init.c,v 1.2 2013/01/20 14:51:10 jacadcaps Exp $
 */

#include "globals.h"

/* public */
#include <exec/memory.h>
#include <proto/exec.h>

/* private */
#include "init.h"


struct Library *CxBase;
struct Library *IconBase;
struct IntuitionBase *IntuitionBase;
struct Library *KeymapBase;
struct DosLibrary *DOSBase;

APTR eventpool;


int init_stuff()
{
	if (IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 39))
	{
		if (DOSBase = (struct DosLibrary *)OpenLibrary("dos.library", 37))
		{
			if (CxBase = OpenLibrary("commodities.library", 37))
			{
				if (IconBase = OpenLibrary("icon.library", 36))
				{
					if (KeymapBase = OpenLibrary("keymap.library", 36))
					{
						if (eventpool = CreatePool(MEMF_CLEAR | MEMF_SEM_PROTECTED, 4096, 2048))
						{
							return (TRUE);
						}
					}
				}
			}
		}
	}

	close_stuff();
	return (FALSE);
}


void close_stuff()
{
	if (eventpool)
	{
		DeletePool(eventpool);
	}

	CloseLibrary(KeymapBase);
	CloseLibrary(IconBase);
	CloseLibrary(CxBase);
	CloseLibrary((struct Library *)DOSBase);
	CloseLibrary((struct Library *)IntuitionBase);
}
